<?php
include_once('initiate.php');
class AjaxForm{
	
	function __construct(){
		$this->response 	= new HTML_AJAX_Action();
		$registry 			= Zend_Registry::getInstance();
		$this->smarty 		= $registry['smarty'];
	}
	
	function setFocus($win_id, $focus_id = '', $sel_style = '', $unsel_style = ''){
		$focus_action = new HTML_AJAX_Action();
		$sel_css = $sel_style == '' ? 'sel_window' : $sel_style;
		$unsel_css = $unsel_style == '' ? 'unsel_window' : $unsel_style;
		$cur_win =& $_SESSION['cur_win'];
		$cur_drag =& $_SESSION['cur_drag'];
		if($cur_win != $win_id){
			if($cur_win != ""){
				if($focus_id == '')
				$focus_action->assignAttr($cur_win, 'class', $unsel_css);
				else{
					$focus_action->assignAttr($cur_drag, 'class', $unsel_css);
					//$focus_action->insertScript("assignClassToChild('$cur_win', '$focus_id', '$unsel_css');");
				}
			}
			$focus_action->assignAttr($cur_win, 'style', "z-index:1;");
			$cur_win = $win_id;
			$cur_drag = $focus_id;
		}
		$focus_action->assignAttr($win_id, 'style', "z-index:100;");
		if($focus_id == '')
			$focus_action->assignAttr($win_id, 'class', $sel_css);
		else{
			$focus_action->assignAttr($focus_id, 'class', $sel_css);
			//$focus_action->insertScript("assignClassToChild('$win_id', '$focus_id', '$sel_css');");
		}
		return $focus_action;
	}
	
	function getDropForm($table, $target_id, $focus_id = '', $template = '', $topstyle = '', $text_size = 10){
		$obj = AjaxCommon::loadModel($table);
		$tpl = $template == '' ? 'drop_form.tpl' : $template;
		$this->smarty->assign('options', $obj->getOptions());
		//$this->smarty->assign('children', $obj->getChildren());
		$this->response->assignAttr($target_id, 'onclick', "ajax_rss.setFocus('$target_id', '$focus_id')");
		$this->displayDropForm($target_id, $tpl, $table);
		$this->response->combineActions($this->setFocus($target_id, $focus_id, $topstyle));
		return $this->response;
	}
	
	function displayDropForm($target_id, $tpl, $table){
		$this->smarty->assign('parent_id', $target_id);
		$this->smarty->assign('table', $table);
		$inner_html = utf8_encode($this->smarty->fetch($tpl));
		//file_put_contents("debug.html", var_export($inner_html, true));
		//exit;
		$this->response->assignAttr($target_id,'innerHTML',$inner_html);
	}
	
	function getDropChildren($id_value, $target_id, $template = ''){
		list($table, ) = explode("-", $target_id);
		$sess_key = $table."_dropchildren";
		$_SESSION[$sess_key]['target_id'] = $target_id;
		$_SESSION[$sess_key]['id_value'] = $id_value;
		$_SESSION[$sess_key]['template'] = $template;
		$this->displayDropChildren($id_value, $target_id, $template, $table);
		return $this->response;
	}

	function displayDropChildren($id_value, $target_id, $template, $table){
		$obj = AjaxCommon::loadModel($table);
		$tpl = $template == '' ? 'drop_children.tpl' : $template;
		//file_put_contents("debug.html", var_export($obj->getChildren($id_value), true));

		$this->smarty->assign('parent_table', $table);
		$this->smarty->assign('parent_id', $id_value);
		$this->smarty->assign('drop_children', $obj->getChildren($id_value));
		$inner_html = utf8_encode($this->smarty->fetch($tpl));
		$this->response->assignAttr($target_id,'innerHTML',$inner_html);

	}

	function dropInsertReference($dragger_id, $target_id){
		list($d_table, $d_id, $d_type) = explode("-", $dragger_id);
		list($t_table, $t_id, $t_type) = explode("-", $target_id);
		//'album_4_dragger collection_1_target'
		//$out = $dragger_id." ".$target_id;
		//file_put_contents("debug.html",var_export($out,true));

		$obj = AjaxCommon::loadModel($t_table);
		$obj->insertReference($d_id, $d_table, $t_id, $t_table);
		$sess_key = $t_table."_dropchildren";
		$sess_val =& $_SESSION[$sess_key];
		$this->displayDropChildren($sess_val['id_value'], $sess_val['target_id'], $sess_val['template'], $t_table);
		return $this->response;
	}

	function listData($table, $target_id, $focus_id = '', $template = '', $topstyle = '', $text_size = 10){
		$_SESSION[$target_id]['desc'] = true;
		$tpl = $template == '' ? 'list.tpl' : $template;
		$_SESSION[$target_id]['tpl'] = $tpl;
		$obj = AjaxCommon::loadModelWithLabels($table);
		$_SESSION[$target_id]['headlines'] = $obj->fields;
		
		$rows = $obj->fetchToArrDeps();
		$_SESSION[$target_id]['rows'] = $rows;
		
		$widths = AjaxCommon::getWidths($rows, $text_size, $obj);
		$_SESSION[$target_id]['widths'] = $widths;
		
		//file_put_contents("debug.html", var_export($widths, true));
		
		$this->response->assignAttr($target_id, 'onclick', "ajax_rss.setFocus('$target_id', '$focus_id')");

		$total_width = array_sum($widths) + 65;
		$this->response->assignAttr($target_id, 'style', "width:{$total_width}px;");

		$this->displayList($table, $target_id, $rows, $widths, $tpl, $obj->fields);
		//$this->response->assignAttr($target_id,'innerHTML',$inner_html);
		//$this->createWindow($origin_id, $target_id, $new_class, $inner_html);
		$this->response->combineActions($this->setFocus($target_id, $focus_id, $topstyle));
		return $this->response;
	}
	
	function displayList($table, $target_id, &$rows, &$widths, $tpl, $headlines){
		$this->smarty->assign('headlines', $headlines);
		$this->smarty->assign('parent_id', $target_id);
		$this->smarty->assign('rows', $rows);
		$this->smarty->assign('widths', $widths);
		$this->smarty->assign('table', $table);
		$inner_html = utf8_encode($this->smarty->fetch($tpl));
		$this->response->assignAttr($target_id,'innerHTML',$inner_html);
	}
	
	function sortData($table, $target_id, $field){
		$rows =& $_SESSION[$target_id]['rows'];
		if($_SESSION[$target_id]['desc']){
			AjaxCommon::sort2DDesc($rows, $field);
			$_SESSION[$target_id]['desc'] = false;
		}else{
			AjaxCommon::sort2DAsc($rows, $field);
			$_SESSION[$target_id]['desc'] = true;
		}
		$this->displayList($table, $target_id, $rows, $_SESSION[$target_id]['widths'], $_SESSION[$target_id]['tpl'], $_SESSION[$target_id]['headlines']);
		return $this->response;
	}
	
	function edit($el_id, $value, $template = false){
		list($table, , $field)  = explode("-", $el_id);
		$obj 					= AjaxCommon::loadModel($table);
		$input_type 			= $obj->fields[$field]["type"];
		$this->smarty->assign('el_id', "{$el_id}-{$input_type}");
		$this->smarty->assign('value', $value);
		$tpl = "";
		switch($input_type){
			case 'text':
				$tpl = $template == false ? 'text_field.tpl' : $template;
				break;
			case 'option':
				$tpl = $template == false ? 'option_field.tpl' : $template;
				$this->smarty->assign('options', AjaxCommon::getOptions($field));
				break;
			default:
				break;
		}
		$inner_html = $this->smarty->fetch($tpl);
		$attributes = array("onclick" => "", "innerHTML" => $inner_html);
		$this->response->assignAttr($el_id, $attributes);
		return $this->response;
	}
	
	function deleteRow($row_id){
		list($table, $id, ) = explode("-", $row_id);
		$obj 				= AjaxCommon::loadModel($table);
		$obj->deleteRecord($id);
		$this->response->removeNode($row_id);
		return $this->response;
	}
	
	function submitValue($value, $el_id, $style = false){
		$css = $style == false ? 'txtfield_fail' : $style;
		list($table, $id, $field, $type) = explode("-", $el_id);
		$obj = AjaxCommon::loadModel($table);
		switch($type){
			case 'text':
				$val_result = Validation::check($obj, $field, $value);
				if($val_result !== true){
					//$this->response->insertScript("alert('$val_result')");
					$this->response->assignAttr($el_id, 'class', $css);
					return $this->response;
				}else{
					$obj->updateField($field, utf8_decode($value), $id);
				}
				break;
			case 'option':
				$obj->updateField($field, $value, $id);
				$field_obj = AjaxCommon::loadModel($field);
				$value = $field_obj->fetchLabel($value);
				break;
		}
		$div_id = $table."-".$id."-".$field;
		$attributes = array('innerHTML' => $value, 'onclick' => "ajax_rss.edit('$div_id', '$value')");
		$this->response->assignAttr($div_id, $attributes);
		return $this->response;
	}
	
	function getInsertForm($table, $target_id, $focus_id = '', $template = '', $topstyle = '', $type = false){
		$obj = AjaxCommon::loadModelWithLabels($table);
		
		switch ($type) {
			case 'update':
				$this->smarty->assign('prepop', $obj->prePop());
				//file_put_contents("debug.html",var_export($obj->session->id, true));
				//exit;
				$this->smarty->assign('update_id', $obj->session->id);
				$this->insertFormCommon($table, $target_id, $template, $obj);
				break;
			default:
				$this->insertFormCommon($table, $target_id, $template, $obj, $type);
				break;
		}
		
		$this->response->assignAttr($target_id, 'onclick', "ajax_rss.setFocus('$target_id', '$focus_id')");
		$this->response->combineActions($this->setFocus($target_id, $focus_id, $topstyle));
		return $this->response;
	}
	
	function insertFormCommon($table, $target_id, $template, &$obj, $type = false){
		$tpl = $template == '' ? 'insert_form.tpl' : $template;
		$this->smarty->assign('table', $table);
		$this->smarty->assign('form_type', $type);
		$this->smarty->assign('parent_id', $target_id);
		$this->smarty->assign('fields', $obj->fetchForm($type));
		$inner_html = $this->smarty->fetch($tpl);
		$this->response->assignAttr($target_id,'innerHTML',$inner_html);
	}
	
	function submitInsertForm($post, $table, $template = '', $style = '', $update_id = false, $type = false){
		$css = $style == '' ? 'txtfield_fail' : $style;
		$post = unserialize(utf8_decode($post));
		$obj = AjaxCommon::loadModelWithLabels($table);
		$insert_arr = Validation::checkForm($obj, $post, $update_id, $type);
		if($insert_arr == false){
			//$this->response->insertScript("alert('$val_result')");
			$this->response->assignAttr($obj->val_error_id."-error", 'innerHTML', $obj->val_error);
			$this->response->assignAttr($obj->val_error_id, 'class', $css);
			return $this->response;
		}
		$insert_arr = array_intersect_key($insert_arr, $obj->colsAsKeys());
		if($update_id != false && $update_id != ''){
			$obj->updateMe($insert_arr, $update_id);
		}else if($type == "login"){
			$this->response->assignAttr("login-msg", 'innerHTML', $obj->authMe($insert_arr));
			return $this->response;
		}else
			$obj->insert($insert_arr);
		$this->insertFormCommon($table, $_SESSION['cur_win'], $template, $obj, $type);
		return $this->response;
	}
	
	function dropHandler($dragger_id, $target_id){
		list($d_table, $d_id, $d_type) = explode("-", $dragger_id);
		list($t_table, $t_id, $t_type) = explode("-", $target_id);
		$t_obj = AjaxCommon::loadModel($t_table);
		$new_values = $t_obj->updateRowWithDeps($d_table, $d_id, $t_id);
		
		if(is_array($new_values)){
			foreach($new_values as $field => $value){
				$this->response->assignAttr("{$t_table}-{$t_id}-{$field}", 'innerHTML', $value);
			}
		}else{
			//$this->response->insertScript("alert('no connection')");
		}
		return $this->response;
	}
}