<?php
class AjaxCommon{
	static function loadModel($table){
		$class_name = ucfirst($table);
		include_once($class_name.".php");
		return new $class_name;
	}
	
	static function loadModelWithLabels($table){
		$obj = self::loadModel($table);
		$obj->createLabels();
		return $obj;
	}
	
	static function smartyAssignKeyValue(&$smarty, &$arr){
		foreach($arr as $key => $value)
			$smarty->assign($key, $value);
	}
	
	static function getWidths(&$rows, $text_size, &$obj){
		$widths = array();
		
		foreach($obj->fields as $key => $value){
			if(strlen($value['label']) > $widths[$key])
				$widths[$key] = strlen($value['label']);
		}
		
		foreach($rows as &$row){
			foreach($row as $key => $value){
				if(strlen($value) > $widths[$key])
					$widths[$key] = strlen($value);
			}
		}
		self::multiply1d($widths, $text_size);
		return $widths;
	}
	
	static function getOptions($field){
		$obj = self::loadModel($field);
		return $obj->getOptions();
	}
	
	static function multiply1d(&$arr, $multiplier){
		foreach($arr as &$value)
		$value *= $multiplier;
	}

	static function sort2DAsc(&$arr, $key){
		//we loop through the array and fetch a value that we store in tmp
		for($i = 0; $i < count($arr); $i++){
			$tmp = $arr[$i];
			$pos = false;
			//we check if the key we want to sort by is a string
			$str = is_string($tmp[$key]);
			if($str){
				//we loop the array again to compare against the temp value we have
				for($j = $i; $j < count($arr); $j++){
					//we string compare, if the string is "smaller" it will be assigned to the temp value
					if(strcasecmp($arr[$j][$key], $tmp[$key]) < 0){
						$tmp = $arr[$j];
						$pos = $j;
					}
				}
			}else{
				for($j = $i; $j < count($arr); $j++){
					if($arr[$j][$key] < $tmp[$key]){
						$tmp = $arr[$j];
						$pos = $j;
					}
				}
			}
			if($pos !== false){
				$arr[$pos] = $arr[$i];
				$arr[$i] = $tmp;
			}
		}
	}

	static function sort2DDesc(&$arr, $key){
		for($i = 0; $i < count($arr); $i++){
			$tmp = $arr[$i];
	  	  	$pos = false;
	  	  	$str = is_string($tmp[$key]);
	  	  	if($str){
				for($j = $i; $j < count($arr); $j++){
					if(strcasecmp($arr[$j][$key], $tmp[$key]) > 0){
					    $tmp = $arr[$j];
					    $pos = $j;
					}
				} 
			}else{
			    for($j = $i; $j < count($arr); $j++){
					if($arr[$j][$key] > $tmp[$key]){
					    $tmp = $arr[$j];
					    $pos = $j;
					}
				}
			}
			if($pos !== false){
			  	$arr[$pos] = $arr[$i];
			  	$arr[$i] = $tmp;
			}
		}
	}

}