<?php
class AjaxModel extends Zend_Db_Table_Abstract{
	protected $_name 			= '';
	protected $_primary 		= '';
	public $label				= '';
	protected $_referenceMap 	= '';
	public $childReferences 	= '';
	public $fields				= '';
	public $headline			= '';
	
	function getModel($table){
		$class_name = ucfirst($table);
		include_once($class_name.".php");
		return new $class_name;
	}
	
	function loadSession(){
		$registry 	= Zend_Registry::getInstance();
		$this->session = $registry[$this->_name];
	}

	function loadTranslation(){
		$registry 	= Zend_Registry::getInstance();
		$this->tr 	= $registry['tr'];
	}
	
	function createLabels(){
		$this->loadTranslation();
	}

	function getHeadline(){
		$this->loadTranslation();
	}

	function getAuthMsg(){
		$this->loadTranslation();
	}
	
	function getChildren($id_value){
		$rarr = array();
		$cur_row = $this->fetchRowToArr($id_value, false);
		foreach($this->childReferences as $i_table => $t_table){
			$result = $cur_row->findManyToManyRowset($t_table, $i_table);
			if(is_object($result)){
				$rows = $result->toArray();
				foreach($rows as &$row){
					$row['i_table'] = 	$this->getModel($i_table)->
					fetchRow(array("{$this->_name} = $id_value", "$t_table = {$row['id']}"))
										->toArray();
				}
				$rarr[] = array(
				'rows' 			=> $rows,
					'i_table' 		=> $i_table,
					'headline' 		=> $this->getModel($t_table)->getHeadline(),
					'row_headline' 	=> $this->getModel($t_table)->label
				); 
			}
		}
		return $rarr;
	}

	function insertReference($d_id, $d_table, $t_id, $t_table){
		foreach($this->childReferences as $ref_table => $drop_table){
			$ref_table = strtolower($ref_table);
			$drop_table = strtolower($drop_table);
			if($d_table == $drop_table){
				$insert_arr = array($t_table => $t_id, $d_table => $d_id); 
				//$insert_arr['ref_table'] = $ref_table;
				//file_put_contents("debug.html",var_export($insert_arr,true));
				$this->getModel($ref_table)->insert($insert_arr);
				//$this->insert($ref_table, $insert_arr);
			}
		}
	}
	
	function fetchToArrDeps($start = false, $limit = false){
		if($limit == false && $start == false)
			$rowset = $this->fetchAll();
		if($this->_referenceMap != ''){
			$rarr = array();
			foreach($rowset as $row){
				foreach($this->_referenceMap as $key => $value){
					$label = $value['refLabel'];
					$cur_row = $row->toArray();
					$parent_row = $row->findParentRow($key);
					if($parent_row != ''){
						$parent_row = $parent_row->toArray();
						$cur_row[$key] = $parent_row[$label];
					}else
						$cur_row[$key] = _("missing_value");
					$rarr[] = $cur_row;
				}
			}
			return $rarr;
		}else
			return $rowset->toArray();
	}
	
	function updateRow($id_value, &$data){
		$where = $this->getAdapter()->quoteInto("{$this->_primary[1]} = ?", $id_value);
		$this->update($data, $where);
	}

	function getRefMapChunk($table){
		return array(
		$this->_referenceMap[$table]['refColumns'],
			$this->_referenceMap[$table]['columns'],
			$this->_referenceMap[$table]['refLabel']
		);
	}
	
	function updateRowWithDeps($parent_table, $parent_id, $this_id){
		$rarr = array();
		$this_row = $this->fetchRowToArr($this_id);
		$parent_row = $this->getModel($parent_table)->fetchRowToArr($parent_id);
		if($parent_row != ''){
			$data = array();
			list($ref_cols, $this_cols, $ref_labels) = $this->getRefMapChunk($parent_table);
			if(is_array($ref_cols)){
				
			}else{
				$data[$this_cols] = $parent_row[$ref_cols];
				$rarr[$this_cols] = $parent_row[$ref_labels];
			}
			$this->updateRow($this_id, $data);
			return $rarr;
		}
		return false;
	}
	
	function fetchForm($auth = false){
		if(!$auth){
			foreach($this->fields as $key => &$value){
				if($value['type'] == 'option'){
					$value['options'] = $this->getModel($key)->getOptions();
				}
			}
			return $this->fields;
		}else{
			$rarr = array();
			foreach($this->fields as $key => &$value){
				if($value['auth'] == $auth){
					$rarr[$key] = $value;
				}
			}
			return $rarr;
		}
	}
	
	function fetchRowToArr($id_value, $as_array = true, $id_field = false, $where = false){
		if($where != false){
			$where_sql = array();
			foreach($where as $field => $value)
				$where_sql[] = $this->getAdapter()->quoteInto("$field = ?", $value);
				
			$row = $this->fetchRow($where_sql);
		}else if($id_field == false){
			$row = $this->find($id_value)->current();
		}else{
			$where = $this->getAdapter()->quoteInto("$id_field = ?", $id_value);
			$row = $this->fetchRow($where);
		}
		if($as_array == true && $row != false)
			return $row->toArray();
		else
			return $row;
	}
	
	function prePop($id_value = false, $id_field = false){
		if($id_value == false){
			$this->loadSession();
			$id_value = $this->session->id;
			if($id_value == false || $id_value == '')
				return false;
		}
		$rarr = $this->fetchRowToArr($id_value, true, $id_field);
		foreach($this->fields as $field => &$field_info){
			$pass_again_parent = $field_info['validation']['pass_again'];
			if($pass_again_parent != '')
				$rarr[$field] =  $rarr[$pass_again_parent];
		}
		return $rarr;
	}
	
	function fetchLabel($id_value){
		$row = $this->fetchRowToArr($id_value);
		return $row[$this->label];
	}
	
	function fetchToArr(){
		$rowset = $this->fetchAll();
		return $rowset->toArray();
	}
	
	function updateField($field, $value, $id_value){
		$data = array($field => $value);
		$where = $this->getAdapter()->quoteInto("{$this->_primary[1]} = ?", $id_value);
		$this->update($data, $where);
	}
	
	function deleteRecord($id_value){
		$where = $this->getAdapter()->quoteInto("{$this->_primary[1]} = ?", $id_value);
		$this->delete($where);
	}
	
	function getOptions(){
		$rows = $this->fetchToArr();
		$rarr = array();
		foreach($rows as &$row){
			$value = $row[$this->_primary[1]];
			$rarr[$value] = $row[$this->label]; 
		}
		return $rarr;
	}
	
	function colsAsKeys(){
		$info = $this->info();
		$fields = $info['cols'];
		$rarr = array();
		foreach($fields as $field) $rarr[$field] = $field;
		return $rarr;
	}
	
	function updateMe(&$set, $id_value, $id_field = false){
		if(!$id_field){
			$where = $this->getAdapter()->quoteInto("{$this->_primary[1]} = ?", $id_value);
		}else{
			$where = $this->getAdapter()->quoteInto("$id_field = ?", $id_value);
		}
		
		$this->update($set, $where);
	}
	
	function authMe($params){
		$row = $this->fetchRowToArr('', true, false, $params);
		if($row != false){
			$this->loadSession();
			$this->session->id = $row[$this->_primary[1]];
			return $this->getAuthMsg(true);
		}else
			return $this->getAuthMsg(false);
	}
	
}