<?php
class Validation{
	
	static function checkForm(&$model, &$post, $update_id = false, $type = false){
		$insert_arr = array();
		foreach($post as $field => &$field_info){
			$value = $field_info['value'];
			$field_result = self::check($model, $field, $value, $post, $update_id, $type);
			if($field_result !== true){
				$model->val_error = $field_result;
				$model->val_error_id = $field_info['id'];
				$model->val_error_field = $field;
				return false;
			}else
				$insert_arr[$field] = $value;
		}
		return $insert_arr;
	}
	
  	static function check(&$model, $field, $value, $post = array(), $update_id = false, $type = false){
  		$registry 	= Zend_Registry::getInstance();
  		$tr 		= $registry['tr'];
  		
  		$validators = $model->fields[$field]["validation"];
  		
  		if(empty($validators))
  			return true;
  			
  		foreach($validators as $key => $validation){
  			if(is_numeric($key) == false){
  				$validator = $key;
  				$condition = $validation;
  			}else{
  				$validator = $validation;
  			}
  			
  			switch ($validator) {
  				case 'atleast':
  					if(strlen($value) < $condition)
  						return $tr->_("valerr_atleast");
  					break;
  				case 'req_email':
  					require_once 'Zend/Validate/EmailAddress.php';
  					$validator = new Zend_Validate_EmailAddress();
  					if ($validator->isValid($value) == false) {
  						return $tr->_("valerr_req_email");
  					}
  					break;
  				case 'pass_again':
  					if($value != $post[$condition]['value'])
  						return $tr->_("valerr_password_again");
  					break;
  				case 'req':
  					if(empty($value))
  						return $tr->_("valerr_required");
  					break;
  				case 'num':
  					if(!is_numeric($value))
  						return $tr->_("valerr_numeric");
  					break;
  				case 'int':
					require_once 'Zend/Validate/Int.php';
					$validator = new Zend_Validate_Int();
					if ($validator->isValid($value) == false)
						return $tr->_("valerr_int");
					break;
  				case 'unique':
  					if($type == "login")
  						return true;
  					$target_row = $model->fetchRowToArr($value, false, $field);
  					if($update_id == false){
	  					if($target_row != false)
	 						return $tr->_("valerr_unique");
  					}else{
  						if($target_row != false){
  							$target_row = $target_row->toArray();
	  						if($update_id != $target_row['id'])
	  							return $tr->_("valerr_unique");
  						}
  					}
 					break;
  				default:
  					break;
  			}
  		}
  		return true;
  	}
}
?>