<?php
class Dbuser extends AjaxModel{
	protected $_name 			= 'dbuser';
	protected $_primary 		= 'id';
	public $label				= 'username';
	protected $_dependentTables = array('Subfeeds');
	
	public $fields = array(
		"username" 		=> array("type" => "text", "auth" => "login", "update" => false, "validation" => array("atleast" => 6,"unique")),
		"email" 		=> array("type" => "text", "update" => false, "validation" => array("req_email")),
		"password" 		=> array("type" => "password", "auth" => "login", "validation" => array("atleast" => 6)),
		"passwordagain" => array("type" => "password", "validation" => array("pass_again" => "password"))
	);
    
	public $childReferences = array("Subfeeds" => "Feeds");
	
	function createLabels(){
		parent::createLabels();
		$this->fields['username']['label'] 		= $this->tr->_("user_username");
		$this->fields['email']['label'] 		= $this->tr->_("user_email");
		$this->fields['password']['label'] 		= $this->tr->_("user_password");
		$this->fields['passwordagain']['label'] = $this->tr->_("user_password_again");
	}
	
	function getHeadline(){
		parent::getHeadline();
		return $this->tr->_("user_headline");
	}
	
	function getAuthMsg($result){
		parent::getAuthMsg();
		if(!$result)
			return $this->tr->_("user_login_fail");
		else
			return $this->tr->_("user_login_ok");
	}
}