<?php
class Feeds extends AjaxModel{
	protected $_name 			= 'feeds';
	protected $_primary 		= 'id';
	public $label				= 'feedname';
	protected $_dependentTables = array('Subfeeds');
	
	public $fields = array(
		"feedname" 		=> array("type" => "text", "validation" => array("req")),
		"link"	 		=> array("type" => "text", "validation" => array("req")),
		"feedtype"		=> array("type" => "option")
	);
	
	protected $_referenceMap    = array(
		'feedtype' => array(
			'columns'           => 'feedtype',
			'refTableClass'     => 'Feedtype',
			'refColumns'        => 'id',
			'refLabel'			=> 'value'
	    )
	);
	
	function createLabels(){
		parent::createLabels();
		$this->fields['feedname']['label'] 	= $this->tr->_("feeds_feedname");
		$this->fields['link']['label'] 		= $this->tr->_("feeds_link");
		$this->fields['feedtype']['label'] 	= $this->tr->_("feeds_type");
	}

	function getHeadline(){
		parent::getHeadline();
		return $this->tr->_("feeds_headline");
	}
	
}